//
// GameX
// Ship Demo - Photon Class Header
//
// Copyright (C) 2002 Rama C. Hoetzlein
// 
// This software is released under the GameX GNU GPL 
// Open Source Liscense. See the GameX documentation included
// with this source code for terms of modification, 
// distribution and re-release. 
// 


#ifndef SHIPDEMO_PHOTONS
	#define SHIPDEMO_PHOTONS

	#include "gamex.hpp"
							
	// Photons are implemented as a simple particle system. 	

	struct Photon {						//*** Photon structure
		float		x, y;				// Position of photon (2D)
		float		dx, dy;				// Velocity of photon
		int			age;				// Age of photon
		int			img;				// Image number of photon (not used)
	};

	class Photons {						//*** Photon class
	public:
		void Initialize (void);			// Initialize photons
		void Move (void);				// Move all photons
		void Draw (int frame);			// Draw all photons

										// Add a photon to the system
		int AddPhoton (float new_x, float new_y, float new_dx, float new_dy);
	private:
		int			num_photons;		// Current number of photons
		int			max_photons;		// Maximum number of photons
		Photon*		photon_list;		// List of photons (ie. 'the particle system')

		ImageX		photon_img[30];		// Photon images (only 1 image currently used)
	};

	

#endif